function C = build_cauchy_matrix(zt, z);

m = length(zt);
k = length(z);
C = zeros(m,k);
for j=1:m
    C(j,:) = cauchy_poly(z,zt(j));
end

function k = cauchy_poly(zi,z)

n = length(zi);
for i=1:n
    ip1 = i+1; if ip1 > n ip1 = 1; end;
    im1 = i-1; if im1 == 0 im1 = n; end;
    k(i) = cauchyc(zi(im1),zi(i),zi(ip1),z);
end

function [k,Ai,Bi,Ci,w,w2,w3] = cauchyc(vim1,vi,vip1,z)

Ai = vi - vim1;
Bi = vim1 - z;
Ci = Ai+Bi;

Aip1 = vip1 - vi;
Bip1 = vi - z;
Cip1 = Aip1+Bip1;

k = 1i*(Bi/Ai*log(Bip1/Bi) - Cip1/Aip1*log(Cip1/Ci));

k = k/(2*pi);

w = (1/Ai*log(Bip1/Bi) - 1/Aip1*log(Cip1/Ci));
w = w/(2*pi*1i);

w2 = 1/(Bip1*Bi) - 1/(Cip1*Ci);
w2 = w2/(2*pi*1i);

w3 = (Bip1+Bi)/(Bip1*Bi)^2 - (Cip1+Ci)/(Cip1*Ci)^2;
w3 = w3/(2*pi*1i);